#include <windows.h>
#include <gdiplus.h>
using namespace Gdiplus;
#pragma comment(lib, "gdiplus")

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("DrawImage");

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	ULONG_PTR gpToken;
	GdiplusStartupInput gpsi;
	if (GdiplusStartup(&gpToken,&gpsi,NULL) != Ok) {
		MessageBox(NULL,"GDI+ ̺귯 ʱȭ  ϴ.","˸",MB_OK);
		return 0;
	}
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);
	
	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	GdiplusShutdown(gpToken);
	return (int)Message.wParam;
}

InterpolationMode imode=InterpolationModeDefault;
void OnPaint(HDC hdc)
{
	Graphics G(hdc);
//* ڷ б
	Image I(L".jpg");

	G.DrawImage(&I,0,0);
//*/
/*  ó
	Image I(L".jpg");
	if (I.GetLastStatus() != Ok) {
		MessageBox(hWndMain,"̹    ϴ.","",MB_OK);
		return;
	}

	G.DrawImage(&I,0,0);
//*/
/* FromFile  Լ б
	Image *pI;
	pI=Image::FromFile(L".jpg");

	G.DrawImage(pI,0,0);
	delete pI;
//*/
/* Ȯ  
	Image I(L"չ.jpg");

	G.DrawImage(&I,0,0,I.GetWidth()*2, I.GetHeight()*2);
	G.DrawImage(&I,0,0,I.GetWidth()/2, I.GetHeight()/2);
//*/
/*   
	Image I(L"չ.jpg");

	G.SetInterpolationMode(imode);
	G.DrawImage(&I,0,0,I.GetWidth()*2, I.GetHeight()*2);
	G.DrawImage(&I,I.GetWidth()*2+10,0,I.GetWidth()/2, I.GetHeight()/2);
//*/
/*  纯 ϱ
	Image I(L"չ.jpg");
	Point pts[]={Point(10,10),Point(300,50),Point(100,300)};

	G.DrawImage(&I,pts,3);
//*/
/* ̹ Ϻκи 
	Image I(L"ȣ.jpg");

	G.DrawImage(&I,0,0,150,40,220,300,UnitPixel);
//*/
/* ̹ Ϻκи  
	Image I(L"ȣ.jpg");

	G.DrawImage(&I,Rect(0,0,110,150),150,40,220,300,UnitPixel);
//*/
/*  纯 Ϻθ ϱ
	Image I(L"ȣ.jpg");
	Point pts[]={Point(10,10),Point(300,50),Point(100,300)};

	G.DrawImage(&I,pts,3,150,40,220,300,UnitPixel);
//*/


/*  
	HICON hIcon;
	hIcon=LoadIcon(NULL,IDI_EXCLAMATION);
	Bitmap B(hIcon);

	G.DrawImage(&B,10,10);
//*/
/*  ۸
	Bitmap B(100,100,&G);
	Graphics G2(&B);
	Pen P(Color(0,0,0),3);

	G2.DrawEllipse(&P,10,10,80,80);
	G.DrawImage(&B,0,0);
//*/
/* ĳ Ʈ
	Bitmap B(L".jpg");
	CachedBitmap CB(&B,&G);

	G.DrawCachedBitmap(&CB,0,0);
//*/
/* Ÿ  
	Image I(L"testenh.emf");	

	G.DrawImage(&I,10,10);
//*/
/* Ÿ    
	Metafile M(L"GpMeta.emf",hdc);
	Graphics *pG=new Graphics(&M);
	Pen P(Color(255,0,0),5);
	Pen P2(Color(0,0,0));

	pG->DrawEllipse(&P,10,10,100,100);
	pG->DrawRectangle(&P2,30,30,50,50);
	delete pG;

	Metafile M2(L"GpMeta.emf");
	G.DrawImage(&M2,10,10);
//*/
/* ̹ Ƽ б
	Image I(L".jpg");
	UINT size,count,i,y=0;
	PropertyItem *arPro;
	TCHAR str[1024];

	I.GetPropertySize(&size,&count);
	arPro=(PropertyItem *)malloc(size);
	I.GetAllPropertyItems(size,count,arPro);

	for (i=0;i<count;i++) {
		switch (arPro[i].id) {
		case PropertyTagImageTitle:
			wsprintf(str," : %s",(TCHAR *)arPro[i].value);
			break;
		case PropertyTagImageDescription:
			wsprintf(str," : %s",(TCHAR *)arPro[i].value);
			break;
		case PropertyTagCopyright:
			wsprintf(str,"۱ : %s",(TCHAR *)arPro[i].value);
			break;
		case PropertyTagEquipMake:
			wsprintf(str," : %s",(TCHAR *)arPro[i].value);
			break;
		case PropertyTagEquipModel:
			wsprintf(str," : %s",(TCHAR *)arPro[i].value);
			break;
		case PropertyTagXResolution:
			wsprintf(str," ػ : %d",*(LONG *)arPro[i].value);
			break;
		case PropertyTagYResolution:
			wsprintf(str," ػ : %d",*(LONG *)arPro[i].value);
			break;
		case PropertyTagSoftwareUsed:
			wsprintf(str," Ʈ : %s",(TCHAR *)arPro[i].value);
			break;
		case PropertyTagDateTime:
			wsprintf(str,"¥ : %s",(TCHAR *)arPro[i].value);
			break;
		default:
			continue;
		}
		TextOut(hdc,0,y*20,str,lstrlen(str));
		y++;
	}

	free(arPro);
//*/
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

	switch(iMessage) {
	case WM_KEYDOWN:
		switch (wParam) {
		case 'I':
			if (imode == InterpolationModeHighQualityBicubic) {
				imode=InterpolationModeDefault;
			} else {
				imode=(InterpolationMode)(imode+1);
			}
			InvalidateRect(hWnd,NULL,FALSE);
			break;
		}
		return 0;
	case WM_CREATE:
		hWndMain=hWnd;
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		OnPaint(hdc);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
