#include <windows.h>
#include <gdiplus.h>
using namespace Gdiplus;
#pragma comment(lib, "gdiplus")

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
HINSTANCE g_hInst;
HWND hWndMain;
LPCTSTR lpszClass=TEXT("GdiPlusBrush");

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	  ,LPSTR lpszCmdParam,int nCmdShow)
{
	HWND hWnd;
	MSG Message;
	WNDCLASS WndClass;
	g_hInst=hInstance;
	ULONG_PTR gpToken;
	GdiplusStartupInput gpsi;
	if (GdiplusStartup(&gpToken,&gpsi,NULL) != Ok) {
		MessageBox(NULL,"GDI+ ̺귯 ʱȭ  ϴ.","˸",MB_OK);
		return 0;
	}
	
	WndClass.cbClsExtra=0;
	WndClass.cbWndExtra=0;
	WndClass.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
	WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
	WndClass.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	WndClass.hInstance=hInstance;
	WndClass.lpfnWndProc=WndProc;
	WndClass.lpszClassName=lpszClass;
	WndClass.lpszMenuName=NULL;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&WndClass);
	
	hWnd=CreateWindow(lpszClass,lpszClass,WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
		NULL,(HMENU)NULL,hInstance,NULL);
	ShowWindow(hWnd,nCmdShow);
	
	while(GetMessage(&Message,0,0,0)) {
		TranslateMessage(&Message);
		DispatchMessage(&Message);
	}
	GdiplusShutdown(gpToken);
	return (int)Message.wParam;
}

REAL angle=0;
BOOL bScale=TRUE;
void OnPaint(HDC hdc)
{
	Graphics G(hdc);
//* ܻ 귯
	SolidBrush S(Color(0,255,0));
	Pen P(Color(255,0,0),3);
	Rect R(10,10,300,150);

	G.FillEllipse(&S,R);
	G.DrawEllipse(&P,R);
//*/
/* ġ 귯
	HatchBrush *pH;
	int Hatch=HatchStyleMin;
	int x,y;

	for (y=0;;y++) {
		for (x=0;x<8;x++) {
			pH=new HatchBrush((HatchStyle)Hatch,Color(0,0,0),Color(255,255,255));
			G.FillRectangle(pH,x*80+10,y*50+10,70,40);
			delete pH;
			Hatch++;
			if (Hatch == HatchStyleMax) return;
		}
	}
//*/
/*  ׷Ʈ 귯
	LinearGradientBrush LGB(Point(0,0),Point(100,0),Color(0,0,255),Color(0,0,0));

	G.FillRectangle(&LGB,0,0,100,100);
	G.FillRectangle(&LGB,10,110,350,100);
//*/
/* 񽺵  ׷Ʈ 귯
	LinearGradientBrush LGB(Point(200,100),Point(400,200),Color(0,0,255),Color(255,255,255));

	G.FillRectangle(&LGB,0,0,600,300);
//*/
/*  ϴ 귯
	LinearGradientBrush LGB(Rect(0,0,200,200),Color(0,0,0),Color(255,255,255),
		angle,bScale);

	G.FillRectangle(&LGB,0,0,200,200);
//*/
/* ؽó 귯
	Image I(L"޷.jpg");
	TextureBrush TB(&I,WrapModeTile);
	//TextureBrush TB(&I,WrapModeTileFlipX);

	RECT crt;
	GetClientRect(hWndMain,&crt);
	G.FillRectangle(&TB,0,0,crt.right,crt.bottom);
//*/
//*/
//*/
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

	switch(iMessage) {
	case WM_KEYDOWN:
		switch (wParam) {
		case VK_UP:
			angle += 5;
			InvalidateRect(hWnd,NULL,FALSE);
			break;
		case VK_DOWN:
			angle -= 5;
			InvalidateRect(hWnd,NULL,FALSE);
			break;
		case VK_SPACE:
			bScale = !bScale;
			InvalidateRect(hWnd,NULL,FALSE);
			break;
		}
		return 0;
	case WM_CREATE:
		hWndMain=hWnd;
		return 0;
	case WM_PAINT:
		hdc=BeginPaint(hWnd, &ps);
		OnPaint(hdc);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
